#include "matrix.h"

int main(int argc, char** argv) {
  --argc; ++argv;
  if (argc != 1) {
    printf("Usage:\n"
           "  gim.bin n\n"
           "Description:\n"
           "  - generates n x n identity matrix\n"
           "  - output file is 'i<n>.mx'\n");
    return 1;
  }

  int n = atoi(argv[0]);
  if (n <= 0) {
    printf("Invalid argument: %s\n", argv[0]);
    return 1;
  }
  printf("Generating %d x %d identity matrix ...\n", n, n);
  double** matrix = matrix_alloc(n, n);
  for (int i = 0 ; i < n; i++) {
    matrix[i][i] = 1.0;
  }

  char file[PATH_MAX+1];
  sprintf(file,"i%d.mx", n);
  printf("Writing to %s ...\n", file);
  matrix_write(file, matrix, n, n);
  matrix_free(matrix);
  return 0;
}
