#include "matrix.h"

int main(int argc, char** argv) {
  --argc; ++argv;
  if (argc != 1  && argc != 2) {
    printf("Usage:\n"
           "  pm.bin binary_file [text_file]\n"
           "Description:\n"
           "  - Prints the contents of matrix stored in binary_file.\n"
           "  - If output text_file is unspecified, prints to stdout.\n");
    return 1;
  }
  const char* inp_file = argv[0];
  FILE* fp = argc == 1 ? stdout : fopen(argv[1], "w");
  if (!fp) {
    perror(argv[1]);
    return 1;
  }
  int m, n; 
  printf("Reading matrix ...\n");
  double** matrix = matrix_read(inp_file, &m, &n);
  if (!matrix) {
    printf("Matrix could not be read!\n");
    return 1;
  }
  printf("Printing matrix ...\n");
  matrix_print(fp, matrix, m, n);
  matrix_free(matrix);
  return 0;
}
